#4.1
data1<-read.csv("wZf[^.csv")

#lmerTestf[^
data1r<-subset(data1, s.sID<16)[c(1,2,3,4,7,9)]
data1r[c(1:17),]


#Anova model by MLM
library(lmerTest)
anovamodel<-lmer(post1~(1|schoolID),data=data1r,REML=FALSE)
summary(anovamodel)


#lavaanf[^
data2<-matrix(0,nrow<-50,ncol<-15)
for(j in 1:50)
{
for(i in 1:15)
{
data2[j,i]<-data1r[15*(j-1)+i,4]
}
}

data2<-data.frame(data2)
colnames(data2)<-c("x1","x2","x3","x4","x5","x6","x7","x8","x9","x10",
"x11","x12","x13","x14","x15")
head(data2)


library(lavaan)
anova.sem <- '
fint =~ 1*x1+1*x2+1*x3+1*x4+1*x5+1*x6+1*x7+1*x8+1*x9+1*x10
+1*x11+1*x12+1*x13+1*x14+1*x15;
x1~~e*x1;x2~~e*x2;x3~~e*x3;x4~~e*x4;x5~~e*x5;
x6~~e*x6;x7~~e*x7;x8~~e*x8;x9~~e*x9;x10~~e*x10;
x11~~e*x11;x12~~e*x12;x13~~e*x13;x14~~e*x14;x15~~e*x15;
fint~~fint;
fint~1;
'

fit.anova.sem <- lavaan(anova.sem, data=data2)
summary(fit.anova.sem, fit.measure=T)


#4.2
data1r.mis<-data1r
set.seed(100)
for(i in 1:nrow(data1r))
{
if(runif(1)<0.2) {data1r.mis[i,4]<-NA;}
}

head(data1r.mis)

anovamodel.mis<-lmer(post1~(1|schoolID),data=data1r.mis,REML=FALSE)
summary(anovamodel.mis)


data2.mis<-matrix(0,nrow<-50,ncol<-15)
for(j in 1:50)
{
for(i in 1:15)
{
data2.mis[j,i]<-data1r.mis[15*(j-1)+i,4]
}
}

data2.mis<-data.frame(data2.mis)
colnames(data2.mis)<-c("x1","x2","x3","x4","x5","x6","x7","x8","x9","x10",
"x11","x12","x13","x14","x15")
head(data2.mis)

fit.anova.sem.mis <- lavaan(anova.sem, data=data2.mis, missing="fiml")
summary(fit.anova.sem.mis, fit.measure=T)


#4.3
data1<-read.csv("wZf[^.csv")[c(1,2,3,4,7,9)]
data1r<-subset(data1, s.sID<16)
data1r.ris<-data.frame(data1r,pre1.01=(data1r$pre1-mean(data1r$pre1)>0)*1)

#_ؕЁE_Xf by MLM
rismodel<-lmer(post1~pre1.01+(1+pre1.01|schoolID),data=data1r.ris,
REML=FALSE)
summary(rismodel)

#_ʂ̐ by MLM
randest<-ranef(rismodel)$schoolID
head(randest)

#pre1.011̌NAꂽf[^data1r.ris0
#pre1.010̌NAꂽf[^data1r.ris1
data1r.ris0<-data.frame(data1r.ris, (1-data1r.ris$pre1.01)^NA-1)
data1r.ris1<-data.frame(data1r.ris, data1r.ris$pre1.01^NA)

data2.ris0<-matrix(0,nrow<-50,ncol<-15)
for(j in 1:50)
{
for(i in 1:15)
{
data2.ris0[j,i]<-data1r.ris0[15*(j-1)+i,4]*(1-data1r.ris0[15*(j-1)+i,8])
}
}

data2.ris1<-matrix(0,nrow<-50,ncol<-15)
for(j in 1:50)
{
for(i in 1:15)
{
data2.ris1[j,i]<-data1r.ris1[15*(j-1)+i,4]*data1r.ris1[15*(j-1)+i,8]
}
}

data2.ris<-data.frame(data2.ris0,data2.ris1)
colnames(data2.ris)<-c("x1","x2","x3","x4","x5","x6","x7","x8","x9","x10",
"x11","x12","x13","x14","x15","x16","x17","x18","x19","x20",
"x21","x22","x23","x24","x25","x26","x27","x28","x29","x30")
head(data2.ris)[,1:15]
head(data2.ris)[,16:30]


library(lavaan)
ris.sem <- '
fint =~ 1*x1+1*x2+1*x3+1*x4+1*x5+1*x6+1*x7+1*x8+1*x9+1*x10
+1*x11+1*x12+1*x13+1*x14+1*x15+1*x16+1*x17+1*x18+1*x19+1*x20
+1*x21+1*x22+1*x23+1*x24+1*x25+1*x26+1*x27+1*x28+1*x29+1*x30;
fslope =~ 1*x16+1*x17+1*x18+1*x19+1*x20
+1*x21+1*x22+1*x23+1*x24+1*x25+1*x26+1*x27+1*x28+1*x29+1*x30;
x1~~e*x1;x2~~e*x2;x3~~e*x3;x4~~e*x4;x5~~e*x5;
x6~~e*x6;x7~~e*x7;x8~~e*x8;x9~~e*x9;x10~~e*x10;
x11~~e*x11;x12~~e*x12;x13~~e*x13;x14~~e*x14;x15~~e*x15;
x16~~e*x16;x17~~e*x17;x18~~e*x18;x19~~e*x19;x20~~e*x20;
x21~~e*x21;x22~~e*x22;x23~~e*x23;x24~~e*x24;x25~~e*x25;
x26~~e*x26;x27~~e*x27;x28~~e*x28;x29~~e*x29;x30~~e*x30;
fint~~fint; fslope~~fslope; fint~~fslope;
fint~1; fslope~1;
'
fit.ris.sem <- lavaan(ris.sem, data=data2.ris, missing="fiml")
summary(fit.ris.sem, fit.measure=T)

#lavaanɂq_̐
head(predict(fit.ris.sem))

#lavaanɂ郉_ʂ̐
head(cbind(predict(fit.ris.sem)[,1]-120.656, predict(fit.ris.sem)[,2]-12.197))



#4.4
#pre1.01̏Wcς̌vZ
pre2.01<-ave(data1r.ris$pre1.01, data1r.ris$schoolID)

#veXg̊wZς̕΍
#ؕЂƌXɊւAf̐ϐɂȂ
pre2.01.mdev<-pre2.01-mean(pre2.01)
data1r.cross<-data.frame(data1r.ris, pre2.01.mdev)

#ؕЁEXɊւAf by MLM
crosslevel<-lmer(post1~pre1.01+pre2.01.mdev+pre1.01:pre2.01.mdev+
(1+pre1.01|schoolID),data=data1r.cross,REML=FALSE)
summary(crosslevel)

a<-seq(1, 750, by = 15)
data2.cross<-data.frame(data2.ris0,data2.ris1,pre2.01.mdev[a])
colnames(data2.cross)<-c("x1","x2","x3","x4","x5","x6","x7","x8","x9",
"x10","x11","x12","x13","x14","x15","x16","x17","x18","x19","x20",
"x21","x22","x23","x24","x25","x26","x27","x28","x29","x30","mdev")


library(lavaan)
cross.sem <- '
fint =~ 1*x1+1*x2+1*x3+1*x4+1*x5+1*x6+1*x7+1*x8+1*x9+1*x10
+1*x11+1*x12+1*x13+1*x14+1*x15+1*x16+1*x17+1*x18+1*x19+1*x20
+1*x21+1*x22+1*x23+1*x24+1*x25+1*x26+1*x27+1*x28+1*x29+1*x30;
fslope =~ 1*x16+1*x17+1*x18+1*x19+1*x20+1*x21+1*x22
+1*x23+1*x24+1*x25+1*x26+1*x27+1*x28+1*x29+1*x30;
fint ~ 1+mdev;
fslope ~ 1+mdev;
x1~~e*x1;x2~~e*x2;x3~~e*x3;x4~~e*x4;x5~~e*x5;
x6~~e*x6;x7~~e*x7;x8~~e*x8;x9~~e*x9;x10~~e*x10;
x11~~e*x11;x12~~e*x12;x13~~e*x13;x14~~e*x14;x15~~e*x15;
x16~~e*x16;x17~~e*x17;x18~~e*x18;x19~~e*x19;x20~~e*x20;
x21~~e*x21;x22~~e*x22;x23~~e*x23;x24~~e*x24;x25~~e*x25;
x26~~e*x26;x27~~e*x27;x28~~e*x28;x29~~e*x29;x30~~e*x30;
fint~~fint; fslope~~fslope; fint~~fslope;
'

fit.cross.sem <- lavaan(cross.sem, data=data2.cross, missing="fiml",
fixed.x=T)
summary(fit.cross.sem, fit.measure=T)


#10.5
data8<-read.csv("cff[^.csv")
data8sem<-matrix(0,nrow<-500,ncol<-5)
for(j in 1:500)
{
for(i in 1:5)
{
data8sem[j,i]<-data8[5*(j-1)+i,2]
}
}
colnames(data8sem)<-c("en0","en1","en2","en3","en4")
head(data8sem)

library(lavaan)
lcm.sem <- '
fint =~ 1*en0+1*en1+1*en2+1*en3+1*en4;
fslope =~ 1*en1+2*en2+3*en3+4*en4;
en0~~e*en0;en1~~e*en1;en2~~e*en2;en3~~e*en3;en4~~e*en4;
fint~~fint; fslope~~fslope; fint~~fslope;
fint~1; fslope~1;
'
fit.lcm.sem <- lavaan(lcm.sem, data=data8sem)
summary(fit.lcm.sem, fit.measure=T)
