data 
{
  int N;
  int J;
  int schoolID[N];
  vector[N] post1;
  vector[N] pre1cwc;
  vector[J] pre2mdev;
  vector[J] time2dev;
} 

parameters 
{
  matrix[J,2] b;      
  cov_matrix[2] T;
  real<lower=0> sigma;  
  real g00;real g01;
  real g02;real g10;
  real g11;real g12;
}

transformed parameters 
{
	vector[N] post1_hat;		
	matrix[J,2] b_hat;
	
	for (i in 1:N)
	{
		post1_hat[i] = b[schoolID[i],1] + b[schoolID[i],2] * pre1cwc[i];
	}	
	
	for(j in 1:J)
	{
		b_hat[j,1] = g00 + g01*pre2mdev[j] + g02*time2dev[j];
		b_hat[j,2] = g10 + g11*pre2mdev[j] + g12*time2dev[j];
	}
} 

model 
{
	for(i in 1:N)
	{
		post1[i] ~ normal(post1_hat[i], sigma);	
	}	
	
	for(j in 1:J)
	{
		b[j,] ~ multi_normal(b_hat[j,], T);		
	}
}
